package org.hibernate.bugs;

import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

/**
 * This template demonstrates how to develop a test case for Hibernate ORM,
 * using the Java Persistence API.
 */
public class JPAUnitTestCase {

    private EntityManagerFactory entityManagerFactory;

    @Before
    public void init() {
        entityManagerFactory = Persistence.createEntityManagerFactory("templatePU");
    }

    @After
    public void destroy() {
        entityManagerFactory.close();
    }

    // Entities are auto-discovered, so just add them anywhere on class-path
    // Add your tests, using standard JUnit.
    @Test
    public void test1() throws Exception {
        EntityManager entityManager = entityManagerFactory.createEntityManager();
        entityManager.getTransaction().begin();
        CriteriaBuilder cb = entityManager.getCriteriaBuilder();
        CriteriaQuery<TestForm> c = cb.createQuery(TestForm.class);
        Root<TestEntity> r = c.from(TestEntity.class);
        c.multiselect(cb.nullLiteral(String.class), cb.nullLiteral(String.class));
        entityManager.createNativeQuery("insert into TEST_HHH_10848 values(1,'OLOLO')").executeUpdate();
        List<TestForm> result = entityManager.createQuery(c).getResultList();
        entityManager.getTransaction().commit();
        entityManager.close();
    }
    
    @Test
    public void test2() throws Exception {
        EntityManager entityManager = entityManagerFactory.createEntityManager();
        entityManager.getTransaction().begin();
        CriteriaBuilder cb = entityManager.getCriteriaBuilder();
        CriteriaQuery<TestForm> c = cb.createQuery(TestForm.class);
        Root<TestEntity> r = c.from(TestEntity.class);
        c.multiselect(r.get("name"), cb.nullLiteral(String.class));
        entityManager.createNativeQuery("insert into TEST_HHH_10848 values(1,'OLOLO')").executeUpdate();
        List<TestForm> result = entityManager.createQuery(c).getResultList();
        entityManager.getTransaction().commit();
        entityManager.close();
    }
}
